INCLUDE \masm32\include\masm32rt.inc
.586
INCLUDE \masm32\macros\timers.asm

.data
buffer BYTE "This is a test string for timing two string length algorithms", 0

.code
;  
;----------------------------------------------------------
;----------------------------------------------------------
ALIGN 16
StrLength PROC USES esi, buf:DWORD
	mov esi, buf
	test esi, 3
	jz IsAligned
	cmp BYTE PTR [esi], NULL
	je done
	add esi, 1
	test esi, 3
	jz IsAligned
	cmp BYTE PTR [esi], NULL
	je done
	add esi, 1
	test esi, 3
	jz IsAligned
	cmp BYTE PTR [esi], NULL
	je done
	add esi, 1
IsAligned:
	sub esi, 32
lbl1:
	add esi, 32
lbl2:
	mov eax, [esi]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero0

	mov eax, [esi+4]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero4

	mov eax, [esi+8]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero8

	mov eax, [esi+12]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero12

	mov eax, [esi+16]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero16

	mov eax, [esi+20]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero20

	mov eax, [esi+24]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero24

	mov eax, [esi+28]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jz lbl1

	add esi, 28
	jmp MightBeZero0
MightBeZero4:
	add esi, 4
	jmp MightBeZero0
MightBeZero8:
	add esi, 8
	jmp MightBeZero0
MightBeZero12:
	add esi, 12
	jmp MightBeZero0
MightBeZero16:
	add esi, 16
	jmp MightBeZero0
MightBeZero20:
	add esi, 20
	jmp MightBeZero0
MightBeZero24:
	add esi, 24
MightBeZero0:
	mov eax, [esi]
	cmp al, 0
	je done
	cmp ah, 0
	je done1
	test eax, 0FF0000h
	je done2
	test eax, 0FF000000h
	je done3

	add esi, 4
	jmp lbl2
done3:
	sub esi, buf
	lea eax, [esi+3]
	jmp @F
done2:
	sub esi, buf
	lea eax, [esi+2]
	jmp @F
done1:
	sub esi, buf
	lea eax, [esi+1]
	jmp @F
done:
	mov eax, esi
	sub eax, buf
@@:
	ret
StrLength ENDP
;----------------------------------------------------------
main PROC
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE StrLen, ADDR buffer
	counter_end
	print ustr$(eax)
	print chr$(" cycles for agner fog StrLen-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE StrLength, ADDR buffer
	counter_end
	print ustr$(eax)
	print chr$(" cycles for StrLength",13,10)

	inkey "--test finished--"
	exit
main ENDP
END main


